﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


//This code was written by a person called Chris van Beek. I came across his code when I was reading his blogg post about him
//creating an application where he gets a livefeed from a similar camera that I was using. The address to his webpage
//is:https://blogs.infosupport.com/writing-an-ip-camera-viewer-in-c-5-0/ where he does a good job explaining his work. 
//You can also download his original sorce code from here.
namespace cCam
{
    public class AutomaticMultiPartReader
    {
        private MultiPartStream _mps;
        private bool _reading = false;
        private byte[] _currentPart;

        public AutomaticMultiPartReader(MultiPartStream stream)
        {
            _mps = stream;
        }

        public event EventHandler<PartReadyEventArgs> PartReady;

        protected virtual void OnPartReady()
        {
            if (PartReady != null)
            {
                PartReadyEventArgs args = new PartReadyEventArgs();
                args.Part = _currentPart;
                PartReady(this, args);
            }
        }
        public async void StartProcessing()
        {
            _reading = true;
            while (_reading)
            {
                _currentPart = await _mps.NextPartAsync().ConfigureAwait(false);
                OnPartReady();
            }
        }

        public void StopProcessing()
        {
            _mps.Close();
            _reading = false;
        }
    }
}
